(in-package :cffi-cairo-snippets)

(defsnippet :arc
  (let ((xc     0.5d0)
	(yc     0.5d0)
	(radius 0.4d0)
	(angle1 (deg-to-rad 45d0))
	(angle2 (deg-to-rad 180d0)))
    (snippet-normalize cr width height)
    (arc cr xc yc radius angle1 angle2)
    (stroke cr)
    ;; draw helping lines
    (set-source-rgba cr 1d0 0.2d0 0.2d0 0.6d0)
    (fill-path cr)
    (set-line-width cr 0.03d0)
    (arc cr xc yc radius angle1 angle2)
    (line-to cr xc yc)
    (arc cr xc yc radius angle2 angle1)
    (line-to cr xc yc)
    (stroke cr)))

(defsnippet :arc-negative
  (let ((xc     0.5d0)
	(yc     0.5d0)
	(radius 0.4d0)
	(angle1 (deg-to-rad 45d0))
	(angle2 (deg-to-rad 180d0)))
    (snippet-normalize cr width height)
    (arc-negative cr xc yc radius angle1 angle2)
    (stroke cr)
    ;; draw helping lines
    (set-source-rgba cr 1d0 0.2d0 0.2d0 0.6d0)
    (fill-path cr)
    (set-line-width cr 0.03d0)
    (arc cr xc yc radius angle1 angle2)
    (line-to cr xc yc)
    (arc cr xc yc radius angle2 angle1)
    (line-to cr xc yc)
    (stroke cr)))