(in-package :cffi-cairo-snippets)

(defsnippet :clip
  (snippet-normalize cr width height)
  (arc cr 0.5d0 0.5d0 0.3d0 0d0 (deg-to-rad 360d0))
  (clip cr)
  (new-path cr) ;; current path is not consumed by clip
  (rectangle cr 0d0 0d0 1d0 1d0)
  (fill-path cr)
  (set-source-rgb cr 0d0 1d0 0d0)
  (move-to cr 0d0 0d0)
  (line-to cr 1d0 1d0)
  (move-to cr 1d0 0d0)
  (line-to cr 0d0 1d0)
  (stroke cr))

(defsnippet :clip-image
  (snippet-normalize cr width height)
  (arc cr 0.5d0 0.5d0 0.3d0 0d0 (deg-to-rad 360d0))
  (clip cr)
  (new-path cr) ;; current path is not consumed by clip
  (let* ((image (image-surface-create-from-png "data/achensee.png"))
	 (w     (image-surface-get-width image))
	 (h     (image-surface-get-height image)))
    (scale cr (/ 1d0 w) (/ 1d0 h))
    (set-source-surface cr image 0d0 0d0)
    (paint cr)
    (destroy image)))